// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_BASICFORM_H
#define _LIBGNOMEDBMM_BASICFORM_H


#include <glibmm.h>

// -*- C++ -*- // 

/* basicform.h
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/box.h>
#include <libgdamm/parameterlist.h>

#include <libgnomedb/gnome-db-basic-form.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbBasicForm GnomeDbBasicForm;
typedef struct _GnomeDbBasicFormClass GnomeDbBasicFormClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class BasicForm_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** @defgroup DbWidgets DbWidgets
 */

/** A GUI form to present data from a Gda::ParameterList.
 *
 * @ingroup DbWidgets
 */

class BasicForm : public Gtk::VBox
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef BasicForm CppObjectType;
  typedef BasicForm_Class CppClassType;
  typedef GnomeDbBasicForm BaseObjectType;
  typedef GnomeDbBasicFormClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~BasicForm();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class BasicForm_Class;
  static CppClassType basicform_class_;

  // noncopyable
  BasicForm(const BasicForm&);
  BasicForm& operator=(const BasicForm&);

protected:
  explicit BasicForm(const Glib::ConstructParams& construct_params);
  explicit BasicForm(GnomeDbBasicForm* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbBasicForm*       gobj()       { return reinterpret_cast<GnomeDbBasicForm*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbBasicForm* gobj() const { return reinterpret_cast<GnomeDbBasicForm*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_param_changed(const Glib::RefPtr<Gda::Parameter>& param, bool is_user_modif);
  virtual void on_activated();
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:


  // This has nothing to do with this class.
  
public:
  explicit BasicForm(const Glib::RefPtr<Gda::ParameterList>& data_set);

  // We currently do not wrap this constructor because the C class has no
  // properties corresponding to the additional arguments but puts all into
  // a GnomeDbFormLayoutSpec struct. IMHO they should split the layout-spec
  // property into four separate properties. This way they could even make
  // that whole layout-spec thing private. armin.
  //
  // Yes, I agree. murrayc.
  //_WRAP_CTOR(BasicForm(const Glib::RefPtr<Gda::ParameterList>& data_set, const std::string& glade_file, const Glib::ustring& root_element, const Glib::ustring& form_prefix), gnome_db_basic_form_new_custom)

  // This returns a GtkDialog containing the new widget, rather than a GnomeDbBasicForm.
  // It is constructor of this class. We could wrap it as a static method that
  // returns an auto_ptr to a new'ed Gtk::Dialog or something, but it also
  // should be easy enough to live without in C++. armin.
  //
  // Yes, I agree. murrayc.
  

  /** Tells @a form  that the current values in the different entries are
   * to be considered as the original values for all the entries; the immediate
   * consequence is that any sub-sequent call to has_been_changed()
   * will return <tt>false</tt> (of course until any entry is changed).
   */
  void set_current_as_orig();
  
  /** Tells if the form can be used as-is (if all the parameters do have some valid values)
   * @return <tt>true</tt> if the form is valid.
   */
  bool is_valid() const;

  
  /** Get a pointer to the Gda::ParameterList object which
   * is modified by @a form 
   */
  Glib::RefPtr<Gda::ParameterList> get_data_set();
  
  /** Get a pointer to the Gda::ParameterList object which
   * is modified by @a form 
   */
  Glib::RefPtr<const Gda::ParameterList> get_data_set() const;

  
  /** Tells if the form has had at least on entry changed, or not
   */
  bool has_been_changed() const;
  
  void show_entry_actions(bool show_actions = true);
  
  /** Resets all the entries in the form to their
   * original values
   */
  void reset();
  
  /** Shows or hides the Gnome::DbDataEntry in @a form  which corresponds to the
   *  @a param  parameter
   * @param param A Gda::Parameter object.
   * @param show Whether the Gnome::DbDataEntry should be shown.
   */
  void entry_show(const Glib::RefPtr<Gda::Parameter>& param, bool show);
  
  /** Sets weather all the Gnome::DbDataEntry entries in the form must default
   * to a default value if they are assigned a non valid value.
   * Depending on the real type of entry, it will provide a default value
   * which the user does not need to modify if it is OK.
   * 
   * For example a date entry can by default display the current date.
   */
  void set_entries_auto_default(bool auto_default = true);
  
  /** For each entry in the form, sets it to a default value if it is possible to do so.
   */
  void set_entries_default();

  
  /** Sets the Gnome::DbDataEntry in @a form  which corresponds to the
   *  @a param  parameter editable or not
   * @param param A Gda::Parameter object.
   * @param editable Whether the Gnome::DbDataEntry should be set editable.
   */
  void entry_set_editable(const Glib::RefPtr<const Gda::Parameter>& param, bool editable = true);
  
  void entry_grab_focus(const Glib::RefPtr<const Gda::Parameter>& parameter);
  
  
  /** Get the Gnome::DbDataEntry in @a form  which corresponds to the param parameter.
   * @param param A Gda::Parameter object.
   * @return The requested widget, or <tt>0</tt> if not found.
   */
  Gtk::Widget* get_entry_widget(const Glib::RefPtr<const Gda::Parameter>& param);
  
  /** Get the Gnome::DbDataEntry in @a form  which corresponds to the param parameter.
   * @param param A Gda::Parameter object.
   * @return The requested widget, or <tt>0</tt> if not found.
   */
  const Gtk::Widget* get_entry_widget(const Glib::RefPtr<const Gda::Parameter>& param) const;
 
  
  /** Get the label in @a form  which corresponds to the param parameter.
   * @param param A Gda::Parameter object.
   * @return The requested widget, or <tt>0</tt> if not found.
   */
  Gtk::Widget* get_label_widget(const Glib::RefPtr<const Gda::Parameter>& param);
  
  /** Get the label in @a form  which corresponds to the param parameter.
   * @param param A Gda::Parameter object.
   * @return The requested widget, or <tt>0</tt> if not found.
   */
  const Gtk::Widget* get_label_widget(const Glib::RefPtr<const Gda::Parameter>& param) const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_headers_sensitive() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_headers_sensitive() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  // This requires us to wrap GnomeDbFormLayoutSpec. However, this is
  // just a plain struct that it is not even registered with the gobject type
  // system. I guess it is not of that much use anyway. armin.
  //
  // Yes, let's ignore it. murrayc. 
  //_WRAP_PROPERTY("layout-spec", GnomeDbFormLayoutSpec*)

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy< Glib::RefPtr<Gda::ParameterList> > property_paramlist() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gda::ParameterList> > property_paramlist() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_show_actions() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_show_actions() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_entries_auto_default() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_entries_auto_default() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  /**
   * @par Prototype:
   * <tt>void %param_changed(const Glib::RefPtr<Gda::Parameter>& param, bool is_user_modif)</tt>
   */

  Glib::SignalProxy2< void,const Glib::RefPtr<Gda::Parameter>&,bool > signal_param_changed();

  
  /**
   * @par Prototype:
   * <tt>void %activated()</tt>
   */

  Glib::SignalProxy0< void > signal_activated();
  

};

} // namespace Db
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::BasicForm
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::BasicForm* wrap(GnomeDbBasicForm* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_BASICFORM_H */

