// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_ENTRYWRAPPER_H
#define _LIBGNOMEDBMM_ENTRYWRAPPER_H


#include <glibmm.h>

// -*- C++ -*- // 

/* entrywrapper.h
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgnomedb/data-entries/gnome-db-entry-wrapper.h>
#include <libgnomedbmm/entryshell.h>
#include <libgnomedbmm/dataentry.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbEntryWrapper GnomeDbEntryWrapper;
typedef struct _GnomeDbEntryWrapperClass GnomeDbEntryWrapperClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class EntryWrapper_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Abstract class that implements the DataEntry interface.
 * This class has several virtual functions which must be implemented by classes which inherit it.
 *
 */

class EntryWrapper : public EntryShell,
                     public DataEntry
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef EntryWrapper CppObjectType;
  typedef EntryWrapper_Class CppClassType;
  typedef GnomeDbEntryWrapper BaseObjectType;
  typedef GnomeDbEntryWrapperClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~EntryWrapper();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class EntryWrapper_Class;
  static CppClassType entrywrapper_class_;

  // noncopyable
  EntryWrapper(const EntryWrapper&);
  EntryWrapper& operator=(const EntryWrapper&);

protected:
  explicit EntryWrapper(const Glib::ConstructParams& construct_params);
  explicit EntryWrapper(GnomeDbEntryWrapper* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbEntryWrapper*       gobj()       { return reinterpret_cast<GnomeDbEntryWrapper*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbEntryWrapper* gobj() const { return reinterpret_cast<GnomeDbEntryWrapper*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
public:
  
  /** Signals to @a gwrap  that the entry has changed
   */
  void contents_changed();
	
  void contents_activated();

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_set_default_if_invalid() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_set_default_if_invalid() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


protected:
  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual Gtk::Widget* create_entry_vfunc();
#endif //GLIBMM_VFUNCS_ENABLED

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual void real_set_value_vfunc(const Gda::Value& value);
#endif //GLIBMM_VFUNCS_ENABLED


  // TODO: This would produce code like return
  // (obj->real_get_value_vfunc()).gobj(); I doubt that this is correct, but I
  // have no idea how to make this work correctly without hand-coding it. armin.
  //_WRAP_VFUNC(Gda::Value real_get_value(), real_get_value)

  // I guess that this has to be hand-coded to get a real C++y API. armin.
  // That's probably impossible. Let's not woryr about it. murrayc.
  //_WRAP_VFUNC(void connect_signals(GCallback callback), real_get_value)

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual bool expand_in_layout_vfunc();
#endif //GLIBMM_VFUNCS_ENABLED

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual void set_editable_vfunc(bool editable);
#endif //GLIBMM_VFUNCS_ENABLED

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual bool value_is_equal_to_vfunc(const Gda::Value& value);
#endif //GLIBMM_VFUNCS_ENABLED

  #ifdef GLIBMM_VFUNCS_ENABLED
  virtual bool value_is_null_vfunc();
#endif //GLIBMM_VFUNCS_ENABLED


};

} // namespace Db
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::EntryWrapper
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::EntryWrapper* wrap(GnomeDbEntryWrapper* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_ENTRYWRAPPER_H */

