// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_ERROR_H
#define _LIBGNOMEDBMM_ERROR_H


#include <glibmm.h>

// -*- C++ -*- // 

/* error.hg
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/box.h>
#include <libgdamm/connectionevent.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbError GnomeDbError;
typedef struct _GnomeDbErrorClass GnomeDbErrorClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class Error_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Error display widget.
 *
 * @ingroup Extras
 * @ingroup DbWidgets
 */

class Error : public Gtk::VBox
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Error CppObjectType;
  typedef Error_Class CppClassType;
  typedef GnomeDbError BaseObjectType;
  typedef GnomeDbErrorClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Error();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Error_Class;
  static CppClassType error_class_;

  // noncopyable
  Error(const Error&);
  Error& operator=(const Error&);

protected:
  explicit Error(const Glib::ConstructParams& construct_params);
  explicit Error(GnomeDbError* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbError*       gobj()       { return reinterpret_cast<GnomeDbError*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbError* gobj() const { return reinterpret_cast<GnomeDbError*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

public:
  Error();
  
  
  /** 
   */
  void clear();
  
  /** Update the given Gnome::DbError widget to show the latest errors
   * from the connection associated with it.
   */
  void show(const Glib::ListHandle< Glib::RefPtr<const Gda::ConnectionEvent > >& errors);
  
  
  /** Display the previous error in the given GnomeDbError widget
   */
  void prev();
  
  /** Display the next error in the given GnomeDbError widget
   */
  void next();
  
  
  /** Get the position of the error being displayed.
   * @return A non-negative integer on success.
   */
  int get_position() const;


};

} // namespace Db
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::Error
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::Error* wrap(GnomeDbError* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_ERROR_H */

