// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_ERRORDIALOG_H
#define _LIBGNOMEDBMM_ERRORDIALOG_H


#include <glibmm.h>

// -*- C++ -*- // 

/* errordialog.hg
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/dialog.h>
#include <libgdamm/connectionevent.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbErrorDialog GnomeDbErrorDialog;
typedef struct _GnomeDbErrorDialogClass GnomeDbErrorDialogClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class ErrorDialog_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Error dialog widget.
 *
 * @ingroup Extras
 * @ingroup DbDialogs
 */

class ErrorDialog : public Gtk::Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef ErrorDialog CppObjectType;
  typedef ErrorDialog_Class CppClassType;
  typedef GnomeDbErrorDialog BaseObjectType;
  typedef GnomeDbErrorDialogClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~ErrorDialog();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class ErrorDialog_Class;
  static CppClassType errordialog_class_;

  // noncopyable
  ErrorDialog(const ErrorDialog&);
  ErrorDialog& operator=(const ErrorDialog&);

protected:
  explicit ErrorDialog(const Glib::ConstructParams& construct_params);
  explicit ErrorDialog(GnomeDbErrorDialog* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbErrorDialog*       gobj()       { return reinterpret_cast<GnomeDbErrorDialog*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbErrorDialog* gobj() const { return reinterpret_cast<GnomeDbErrorDialog*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

public:
  explicit ErrorDialog(const Glib::ustring& title);
  
  
  /** Pops up the given GnomeDbErrorDialog widget, displaying any errors that
   * may be reported for the connection being used by this widget
   * @param error_list List of errors to show.
   */
  void show_errors(const Glib::ListHandle< Glib::RefPtr<const Gda::ConnectionEvent > >& error_list);
  
  /** Change the title for the given GnomeDbErrorDialog widget
   * @param title Title to be shown.
   */
  void set_title(const Glib::ustring& title);
  
  Glib::ustring get_title() const;


};

} // namespace Db
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::ErrorDialog
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::ErrorDialog* wrap(GnomeDbErrorDialog* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_ERRORDIALOG_H */

