// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_GRAYBAR_H
#define _LIBGNOMEDBMM_GRAYBAR_H


#include <glibmm.h>

// -*- C++ -*- // 

/* graybar.hg
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/bin.h>
#include <gtkmm/stock.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbGrayBar GnomeDbGrayBar;
typedef struct _GnomeDbGrayBarClass GnomeDbGrayBarClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class GrayBar_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Nice looking gray bar widget.
 *
 * @ingroup Extras
 */

class GrayBar : public Gtk::Bin
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef GrayBar CppObjectType;
  typedef GrayBar_Class CppClassType;
  typedef GnomeDbGrayBar BaseObjectType;
  typedef GnomeDbGrayBarClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~GrayBar();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class GrayBar_Class;
  static CppClassType graybar_class_;

  // noncopyable
  GrayBar(const GrayBar&);
  GrayBar& operator=(const GrayBar&);

protected:
  explicit GrayBar(const Glib::ConstructParams& construct_params);
  explicit GrayBar(GnomeDbGrayBar* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbGrayBar*       gobj()       { return reinterpret_cast<GnomeDbGrayBar*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbGrayBar* gobj() const { return reinterpret_cast<GnomeDbGrayBar*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

public:
  explicit GrayBar(const Glib::ustring& text);
     
  
  /** Set the text displayed in the given gray bar widget. This can include 
   * embedded underlines indicating mnemonics or Pango markup.
   */
  void set_text(const Glib::ustring& text);
  
  /** Get the text being displayed in the given gray bar widget. This
   * does not include any embedded underlines indicating mnemonics or
   * Pango markup.
   * @return The text in the widget.
   */
  Glib::ustring get_text() const;
  
  
  void set_icon_from_file(const std::string& filename);
  
  void set_icon_from_stock(const Gtk::StockID& stock_id, Gtk::IconSize size);
  
  
  /** Set the icon displaying mode for the given grid.
   * @param show Whether to show the icon or not.
   */
  void set_show_icon(bool show = true);
  
  /** Get whether the icon is being shown for the given gray bar.
   * @return <tt>true</tt> if the icon is shown, <tt>false</tt> if not.
   */
  bool get_show_icon() const;
  

};

} // namespace Db
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::GrayBar
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::GrayBar* wrap(GnomeDbGrayBar* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_GRAYBAR_H */

