// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_PROVIDERSELECTOR_H
#define _LIBGNOMEDBMM_PROVIDERSELECTOR_H


#include <glibmm.h>

// -*- C++ -*- // 

/* providerselector.hg
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <libgdamm/serverprovider.h>
#include <libgnomedbmm/combo.h>

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbProviderSelector GnomeDbProviderSelector;
typedef struct _GnomeDbProviderSelectorClass GnomeDbProviderSelectorClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class ProviderSelector_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** A ComboBox-style widget to select a provider.
 *
 * @ingroup DbWidgets
 */

class ProviderSelector : public Combo
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef ProviderSelector CppObjectType;
  typedef ProviderSelector_Class CppClassType;
  typedef GnomeDbProviderSelector BaseObjectType;
  typedef GnomeDbProviderSelectorClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~ProviderSelector();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class ProviderSelector_Class;
  static CppClassType providerselector_class_;

  // noncopyable
  ProviderSelector(const ProviderSelector&);
  ProviderSelector& operator=(const ProviderSelector&);

protected:
  explicit ProviderSelector(const Glib::ConstructParams& construct_params);
  explicit ProviderSelector(GnomeDbProviderSelector* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbProviderSelector*       gobj()       { return reinterpret_cast<GnomeDbProviderSelector*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbProviderSelector* gobj() const { return reinterpret_cast<GnomeDbProviderSelector*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
  public:
    ProviderSelector();


  /** Forces @a selector  to be set on @a provider 
   * @param provider The provider to be selected.
   * @return <tt>true</tt> if @a provider  has been selected.
   */
  bool set_selected_provider(const Glib::ustring& provider);    
    
  /** Get the selected provider.
   * @return The selected provider.
   */
  Glib::ustring get_selected_provider() const;

    
  /** Get the selected provider as a Gda::ServerProvider object
   * @return A new Gda::ServerProvider or <tt>0</tt> if an error occurred.
   */
  Glib::RefPtr<Gda::ServerProvider> get_selected_provider_obj();
    
  /** Get the selected provider as a Gda::ServerProvider object
   * @return A new Gda::ServerProvider or <tt>0</tt> if an error occurred.
   */
  Glib::RefPtr<const Gda::ServerProvider> get_selected_provider_obj() const;


};

} // namespace Db

} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::ProviderSelector
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::ProviderSelector* wrap(GnomeDbProviderSelector* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_PROVIDERSELECTOR_H */

