// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGNOMEDBMM_RAWGRID_H
#define _LIBGNOMEDBMM_RAWGRID_H


#include <glibmm.h>

// -*- C++ -*- // 

/* rawgrid.h
 * 
 * Copyright 2006 libgnomedbmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/treeview.h>
#include <gtkmm/menu.h>
#include <libgdamm/datamodel.h>
#include <libgnomedbmm/datawidget.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GnomeDbRawGrid GnomeDbRawGrid;
typedef struct _GnomeDbRawGridClass GnomeDbRawGridClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Db
{ class RawGrid_Class; } // namespace Db

} // namespace Gnome
namespace Gnome
{

namespace Db
{

/** Grid to display and modify data in a Gda::DataModel.
 * This widget only contains data - it has no decoration, or button to change the displayed row, or any indicator 
 * about the current displayed row or the total number of rows. To have a complete grid widget, see the Grid class.
 *
 * This widget is itself a Gtk::TreeView widget. 
 *
 * @ingroup DbWidgets
 */

class RawGrid
 : public Gtk::TreeView,
   public DataWidget
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef RawGrid CppObjectType;
  typedef RawGrid_Class CppClassType;
  typedef GnomeDbRawGrid BaseObjectType;
  typedef GnomeDbRawGridClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~RawGrid();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class RawGrid_Class;
  static CppClassType rawgrid_class_;

  // noncopyable
  RawGrid(const RawGrid&);
  RawGrid& operator=(const RawGrid&);

protected:
  explicit RawGrid(const Glib::ConstructParams& construct_params);
  explicit RawGrid(GnomeDbRawGrid* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GnomeDbRawGrid*       gobj()       { return reinterpret_cast<GnomeDbRawGrid*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GnomeDbRawGrid* gobj() const { return reinterpret_cast<GnomeDbRawGrid*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  virtual void on_double_clicked(int row);
  virtual void on_populate_popup(Gtk::Menu* menu);
  virtual void on_selection_changed(bool row_selected);
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


private:

  
public:
  explicit RawGrid(const Glib::RefPtr<Gda::DataModel>& model);

  #ifndef DOXYGEN_SHOULD_SKIP_THIS
  // I wonder why there is no such thing in glibmm.
  // Is this really that uncommon? armin.
  struct IntTraits
  {
    typedef int  CppType;
    typedef gpointer CType;
    typedef gpointer CTypeNonConst;

    static CType   to_c_type      (const CppType& obj) { return GINT_TO_POINTER(obj); }
    static CType   to_c_type      (const CType&   obj) { return GINT_TO_POINTER(obj); }
    static CppType to_cpp_type    (const CType&   obj) { return GPOINTER_TO_INT(obj); }
    static void    release_c_type (const CType&)       {}
  };
  #endif //DOXYGEN_SHOULD_SKIP_THIS

  typedef Glib::ListHandle<int, IntTraits> IntListHandle;

  // Fully qualify the IntListHandle type here to make it available in
  // the generated code.
   

  /** Returns: a new list, should be freed (by calling g_list_free) when no longer needed.
   * @return A new list, should be freed (by calling g_list_free) when no longer needed.
   */
  RawGrid::IntListHandle get_selection() const;

  
  /** 
   */
  void set_sample_size(int sample_size);
  
  /** 
   */
  void set_sample_start(int sample_start);

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Global Actions visible.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_global_actions_visible() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Global Actions visible.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_global_actions_visible() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** Info cell visible.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<bool> property_info_cell_visible() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** Info cell visible.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<bool> property_info_cell_visible() const;
#endif //#GLIBMM_PROPERTIES_ENABLED

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy< Glib::RefPtr<Gda::DataModel> > property_model() ;
#endif //#GLIBMM_PROPERTIES_ENABLED

#ifdef GLIBMM_PROPERTIES_ENABLED
/** 
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gda::DataModel> > property_model() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


  /**
   * @par Prototype:
   * <tt>void %double_clicked(int row)</tt>
   */

  Glib::SignalProxy1< void,int > signal_double_clicked();

  
  /**
   * @par Prototype:
   * <tt>void %populate_popup(Gtk::Menu* menu)</tt>
   */

  Glib::SignalProxy1< void,Gtk::Menu* > signal_populate_popup();

  
  /**
   * @par Prototype:
   * <tt>void %selection_changed(bool row_selected)</tt>
   */

  Glib::SignalProxy1< void,bool > signal_selection_changed();


};

} // namespace Db
} // namespace Gnome


namespace Glib
{
  /** @relates Gnome::Db::RawGrid
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Gnome::Db::RawGrid* wrap(GnomeDbRawGrid* object, bool take_copy = false);
} //namespace Glib


#endif /* _LIBGNOMEDBMM_RAWGRID_H */

